

//加载并初始化模板对象
var goodsTemplate = loadTemplate("../assets/templates/goods.html");

<!-- 列表单条商品条目VIEW-->
var goodsView = Backbone.View.extend({//options...
    initialize : function(option) {
        //初始化VIEW并让model与VIEW进行关联
        this.model.view = this;
        //初始化VIEW的HTMLDOM对象
        this.render();
    },
    template : goodsTemplate, //VIEW对应的模板
    render : function() { 
        if (this.template) {
            //使用模板+数据拼装DOM
            this.$el = $(this.template(this.model.attributes));
            //为DOM增加点击效果
            appcan.button(this.$el, "btn-act", function() {
                console.log(this)
                //console.log(console.log(this.model));
            })
        }
        //返回自身，便于promise调用
        return this;
    }
});


//列表容器VIEW
var goodsListView = Backbone.View.extend({//options...
    
    initialize : function() {
        //初始化集合与VIEW自身函数的关联
        this.listenTo(this.collection, "add", this.add);
        this.listenTo(this.collection, 'sort', this.sort);
        //初始化服务与VIEW自身函数的关联
        this.viewCollection=this.collection;
        
    },
    collection : new goodsCollection(), //collection，用于存储和管理数据
    el : '#goodsList > ul',   //VIEW 对应 HTML 元素CSS选择器
    load : function() {  //HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        this.collection.fetch({success:function(cols, resp, options){
            $("div.lazy").lazyload({
                cache:false
            });
        },error:function(cols, error, options){
        }});
    },
    add : function(model) {
        //collection中每加入一条数据都会被调用，用于创建新的商品view
        var view = new goodsView({
            model : model
        });
        //把条目view的dom对象插入到listview DOM对象中
        this.$el.append(view.$el);
    },
    orderBy:function(order){
      this.viewCollection.orderBy=order?order:1;
      this.viewCollection.sort();
      //重新进行懒加载避免重排之后某些图片没有触发懒加载
      $("div.lazy").lazyload({
            cache:false
        }); 
    },
    filterByPrice:function(start,end){
        var items = this.collection.filter(function(m){
            var price = m.get("price");
            return ( price > start && price < end)?true:false
        });
        this.viewCollection = new goodsCollection();//为筛选出来的数据建立集合对象用于支持显示。
        this.viewCollection.set(items);
        this.$el.empty();
        this.listenTo(this.viewCollection, 'sort', this.sort); //为筛选出来的数据建立集合对象注册排序事件
        this.viewCollection.sort();
        $("div.lazy").lazyload({
            cache:false
        }); 
    },
    sort : function() {
        //按照collection中的数据顺序，变更model相关view在listview中的排序
        for (var i = 0; i < this.viewCollection.length; i++) {
            var model = this.viewCollection.models[i];
            if (model.view) {
                this.$el.append(model.view.$el);
            }
        }
    }
});

var goodsListViewInstance = new goodsListView();
