//加载并初始化模板对象
var orderTemplate = loadTemplate("../assets/templates/order.html");

var orderView = Backbone.View.extend({//options...
    initialize : function(option) {
        //初始化VIEW并让model与VIEW进行关联
        this.model.view = this;
        //初始化VIEW的HTMLDOM对象
        this.render();
    },
    template : orderTemplate, //VIEW对应的模板
    render : function() {
        var self = this;
        if (this.template) {
            //使用模板+数据拼装DOM
            this.$el = $(this.template(this.model.attributes));
            //为DOM增加点击效果
            appcan.button($("div.lazy", this.$el), "btn-act", function() {
                //点击图片打开产品
                var i = $(this).data("index");
                //获取产品在数组中的索引
                var item = self.model.attributes.items[i];
                //获取产品对象
                //////打开产品详情
            })
        }
        //返回自身，便于promise调用
        return this;
    }
});

//列表容器VIEW
var orderListView = Backbone.View.extend({//options...

    initialize : function() {
        //初始化集合与VIEW自身函数的关联
        this.listenTo(this.collection, "add", this.add);
        this.listenTo(this.collection, 'sort', this.sort);
    },
    collection : new orderCollection(), //collection，用于存储和管理数据
    el : '#orderlist > ul', //VIEW 对应 HTML 元素CSS选择器
    load : function() {//HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        this.collection.fetch({
            success : function(cols, resp, options) {
                $("div.lazy").lazyload({
                    cache : false //使用icache缓存图片到本地然后显示则设定为true，否则为false，但WEB模式要设定为false
                });
            },
            error : function(cols, resp, options) {

            }
        });
    },
    add : function(model) {
        //collection中每加入一条数据都会被调用，用于创建新的订单view
        var view = new orderView({
            model : model
        });
        //把条目view的dom对象插入到listview DOM对象中
        this.$el.append(view.$el);
    },
    sort : function() {
        //按照collection中的数据顺序，变更model相关view在listview中的排序
        for (var i = 0; i < this.collection.length; i++) {
            var model = this.collection.models[i];
            if (model.view) {
                this.$el.append(model.view.$el);
            }
        }
    }
});

var orderListViewInstance = new orderListView();
